diff --git a/gcc/m2/mc/decl.mod b/gcc/m2/mc/decl.mod
index 8293c7f5d1f..356290b349c 100644
--- a/gcc/m2/mc/decl.mod
+++ b/gcc/m2/mc/decl.mod
@@ -662,6 +662,7 @@ TYPE
        defT = RECORD
                  name             :  Name ;
                  source           :  Name ;
+                 unqualified,
 		 hasHidden,
                  forC             :  BOOLEAN ;
                  exported,
@@ -721,6 +722,8 @@ VAR
    globalGroup   : group ;    (* The global group of all alists.  *)
    outputFile    : File ;
    lang          : language ;
+   charStarN,
+   constCharStarN,
    bitsperunitN,
    bitsperwordN,
    bitspercharN,
@@ -1187,6 +1190,47 @@ BEGIN
 END importEnumFields ;
 
 
+(*
+   checkGccType - check to see if node n is gcc tree or location_t
+                  and record its use in keyc.
+*)
+
+PROCEDURE checkGccType (n: node) ;
+BEGIN
+   IF getGccConfigSystem () AND (getScope (n) # NIL) AND
+      (getSymName (getScope (n)) = makeKey ('gcctypes'))
+   THEN
+      IF getSymName (n) = makeKey ('location_t')
+      THEN
+         keyc.useGccLocation
+      ELSIF getSymName (n) = makeKey ('tree')
+      THEN
+         keyc.useGccTree
+      END
+   END
+END checkGccType ;
+
+
+(*
+   checkCDataTypes - check to see if node n is CharStar or ConstCharStar
+                  and if necessary assign n to the global variable.
+*)
+
+PROCEDURE checkCDataTypes (n: node) ;
+BEGIN
+   IF (getScope (n) # NIL) AND (getSymName (getScope (n)) = makeKey ('CDataTypes'))
+   THEN
+      IF getSymName (n) = makeKey ('CharStar')
+      THEN
+         charStarN := n
+      ELSIF getSymName (n) = makeKey ('ConstCharStar')
+      THEN
+         constCharStarN := n
+      END
+   END
+END checkCDataTypes ;
+
+
 (*
    import - attempts to add node, n, into the scope of module, m.
             It might fail due to a name clash in which case the
@@ -1201,6 +1245,8 @@ VAR
 BEGIN
    assert (isDef (m) OR isModule (m) OR isImp (m)) ;
    name := getSymName (n) ;
+   checkGccType (n) ;
+   checkCDataTypes (n) ;
    r := lookupInScope (m, name) ;
    IF r=NIL
    THEN
@@ -1563,6 +1609,7 @@ BEGIN
       defF.source := NulName ;
       defF.hasHidden := FALSE ;
       defF.forC := FALSE ;
+      defF.unqualified := FALSE ;
       defF.exported := InitIndex (1) ;
       defF.importedModules := InitIndex (1) ;
       defF.constFixup := initFixupInfo () ;
@@ -1653,6 +1700,33 @@ BEGIN
 END isDefForC ;
 
 
+(*
+   putDefUnqualified - the definition module uses unqualified.
+*)
+
+PROCEDURE putDefUnqualified (n: node) ;
+BEGIN
+   assert (isDef (n)) ;
+   (* Currently (and this is a temporary development restriction to
+      reduce any search space for bugs) the only module which can be
+      export unqualified is gcctypes.  *)
+   IF n^.defF.name = makeKey ('gcctypes')
+   THEN
+      n^.defF.unqualified := TRUE
+   END
+END putDefUnqualified ;
+
+
+(*
+   isDefUnqualified - returns TRUE if the definition module uses unqualified.
+*)
+
+PROCEDURE isDefUnqualified (n: node) : BOOLEAN ;
+BEGIN
+   RETURN isDef (n) AND n^.defF.unqualified
+END isDefUnqualified ;
+
+
 (*
    lookupDef - returns a definition module node named, n.
 *)
@@ -3555,7 +3629,7 @@ BEGIN
       THEN
          RETURN getNextFixup (impF.constFixup)
       ELSE
-         assert (isModule (currentModule))
+         assert (isModule (currentModule)) ;
          RETURN getNextFixup (moduleF.constFixup)
       END
    END
@@ -5421,7 +5495,7 @@ END getExprType ;
 
 PROCEDURE skipType (n: node) : node ;
 BEGIN
-   WHILE (n#NIL) AND isType (n) DO
+   WHILE (n#NIL) AND isType (n) AND (NOT isCDataType (n)) DO
       IF getType (n) = NIL
       THEN
          (* this will occur if, n, is an opaque type.  *)
@@ -5720,7 +5794,7 @@ PROCEDURE getFQstring (n: node) : String ;
 VAR
    i, s: String ;
 BEGIN
-   IF getScope (n) = NIL
+   IF (getScope (n) = NIL) OR (isDefUnqualified (getScope (n)))
    THEN
       RETURN InitStringCharStar (keyToCharStar (getSymName (n)))
    ELSIF isQualifiedForced (n)
@@ -5728,7 +5802,7 @@ BEGIN
       i := InitStringCharStar (keyToCharStar (getSymName (n))) ;
       s := InitStringCharStar (keyToCharStar (getSymName (getScope (n)))) ;
       RETURN Sprintf2 (InitString ("%s_%s"), s, i)
-   ELSIF (NOT isExported (n)) OR getIgnoreFQ ()
+   ELSIF (NOT isExported (n)) OR getIgnoreFQ () OR (isDefUnqualified (getScope (n)))
    THEN
       RETURN InitStringCharStar (keyToCharStar (getSymName (n)))
    ELSE
@@ -5747,7 +5821,7 @@ PROCEDURE getFQDstring (n: node; scopes: BOOLEAN) : String ;
 VAR
    i, s: String ;
 BEGIN
-   IF getScope (n) = NIL
+   IF (getScope (n) = NIL) OR (isDefUnqualified (getScope (n)))
    THEN
       RETURN InitStringCharStar (keyToCharStar (getDName (n, scopes)))
    ELSIF isQualifiedForced (n)
@@ -5756,7 +5830,7 @@ BEGIN
       i := InitStringCharStar (keyToCharStar (getSymName (n))) ;
       s := InitStringCharStar (keyToCharStar (getSymName (getScope (n)))) ;
       RETURN Sprintf2 (InitString ("%s_%s"), s, i)
-   ELSIF (NOT isExported (n)) OR getIgnoreFQ ()
+   ELSIF (NOT isExported (n)) OR getIgnoreFQ () OR (isDefUnqualified (getScope (n)))
    THEN
       RETURN InitStringCharStar (keyToCharStar (getDName (n, scopes)))
    ELSE
@@ -8250,6 +8324,173 @@ BEGIN
 END doTypeNameModifier ;
 
 
+(*
+   isGccType - return TRUE if n is tree or location_t.
+*)
+
+PROCEDURE isGccType (n: node) : BOOLEAN ;
+BEGIN
+   RETURN (getGccConfigSystem () AND
+           ((getSymName (n) = makeKey ('location_t')) OR
+            (getSymName (n) = makeKey ('tree'))))
+END isGccType ;
+
+
+(*
+   doGccType - record whether we are going to declare tree or location_t
+               so that the appropriate gcc header can be included instead.
+*)
+
+PROCEDURE doGccType (p: pretty; n: node) ;
+BEGIN
+   IF getGccConfigSystem ()
+   THEN
+      IF getSymName (n) = makeKey ('location_t')
+      THEN
+         outText (p, "/* Not going to declare ") ;
+         doTypeNameC (p, n) ;
+         outText (p, " as it is declared in the gcc header input.h.  */\n\n") ;
+         keyc.useGccLocation
+      ELSIF getSymName (n) = makeKey ('tree')
+      THEN
+         outText (p, "/* Not going to declare ") ;
+         doTypeNameC (p, n) ;
+         outText (p, " as it is declared in the gcc header tree.h.  */\n\n") ;
+         keyc.useGccTree
+      END
+   END
+END doGccType ;
+
+
+(*
+   isCDataType - return true if n is charStar or constCharStar.
+*)
+
+PROCEDURE isCDataType (n: node) : BOOLEAN ;
+BEGIN
+   RETURN (n # NIL) AND ((n = charStarN) OR (n = constCharStarN))
+END isCDataType ;
+
+
+(*
+   isCDataTypes - return TRUE if n is CharStar or ConstCharStar.
+*)
+
+PROCEDURE isCDataTypes (n: node) : BOOLEAN ;
+VAR
+   scope: node ;
+BEGIN
+   scope := getScope (n) ;
+   RETURN (scope # NIL) AND (getSymName (scope) = makeKey ('CDataTypes')) AND
+            ((getSymName (n) = makeKey ('CharStar')) OR
+             (getSymName (n) = makeKey ('ConstCharStar')))
+END isCDataTypes ;
+
+
+(*
+   doCDataTypes - if we are going to declare CharStar or ConstCharStar
+               then generate a comment instead.
+*)
+
+PROCEDURE doCDataTypes (p: pretty; n: node) ;
+BEGIN
+   IF isCDataTypes (n)
+   THEN
+      IF getSymName (n) = makeKey ('CharStar')
+      THEN
+         outText (p, "/* Not going to declare ") ;
+         doTypeNameC (p, n) ;
+         outText (p, " as it is a C type.  */\n\n") ;
+         charStarN := n
+      ELSIF getSymName (n) = makeKey ('ConstCharStar')
+      THEN
+         outText (p, "/* Not going to declare ") ;
+         doTypeNameC (p, n) ;
+         outText (p, " as it is a C type.  */\n\n") ;
+         constCharStarN := n
+      END
+   END
+END doCDataTypes ;
+
+
+(*
+   doCDataTypesC - generate the C representation of the CDataTypes data types.
+*)
+
+PROCEDURE doCDataTypesC (p: pretty; n: node) ;
+BEGIN
+   IF n = charStarN
+   THEN
+      outText (p, "char *") ;
+      setNeedSpace (p)
+   ELSIF n = constCharStarN
+   THEN
+      outText (p, "const char *") ;
+      setNeedSpace (p)
+   END
+END doCDataTypesC ;
+
+
+(*
+   doTypeOrPointer - only declare type or pointer n providing that
+                     the name is not location_t or tree and
+                     the --gccConfigSystem option is enabled.
+*)
+
+PROCEDURE doTypeOrPointer (p: pretty; n: node) ;
+VAR
+   m: node ;
+BEGIN
+   IF isGccType (n)
+   THEN
+      doGccType (p, n)
+   ELSIF isCDataTypes (n)
+   THEN
+      doCDataTypes (p, n)
+   ELSE
+      m := getType (n) ;
+      outText (p, "typedef") ; setNeedSpace (p) ;
+      doTypeC (p, m, m) ;
+      IF isType (m)
+      THEN
+         setNeedSpace (p)
+      END ;
+      doTypeNameC (p, n) ;
+      doTypeNameModifier (p, n) ;
+      outText (p, ";\n\n")
+   END
+END doTypeOrPointer ;
+
+
+(*
+   doTypedef - generate a typedef for n provuiding it is not
+*)
+
+PROCEDURE doTypedef (p: pretty; n: node) ;
+VAR
+   m: node ;
+BEGIN
+   IF isGccType (n)
+   THEN
+      doGccType (p, n)
+   ELSIF isCDataTypes (n)
+   THEN
+      doCDataTypes (p, n)
+   ELSE
+      m := getType (n) ;
+      outText (p, "typedef") ; setNeedSpace (p) ;
+      doTypeC (p, m, m) ;
+      IF isType (m)
+      THEN
+         setNeedSpace (p)
+      END ;
+      doTypeNameC (p, n) ;
+      doTypeNameModifier (p, n) ;
+      outText (p, ";\n\n")
+   END
+END doTypedef ;
+
+
 (*
    doTypesC -
 *)
@@ -8266,15 +8507,7 @@ BEGIN
          doProcTypeC (doP, n, m)
       ELSIF isType (m) OR isPointer (m)
       THEN
-         outText (doP, "typedef") ; setNeedSpace (doP) ;
-         doTypeC (doP, m, m) ;
-	 IF isType (m)
-         THEN
-            setNeedSpace (doP)
-         END ;
-         doTypeNameC (doP, n) ;
-         doTypeNameModifier (doP, n) ;
-         outText (doP, ";\n\n")
+         doTypeOrPointer (doP, n)
       ELSIF isEnumeration (m)
       THEN
          IF isDeclType (n)
@@ -8286,15 +8519,7 @@ BEGIN
             outText (doP, ";\n\n")
          END
       ELSE
-         outText (doP, "typedef") ; setNeedSpace (doP) ;
-         doTypeC (doP, m, m) ;
-	 IF isType (m)
-         THEN
-            setNeedSpace (doP)
-         END ;
-         doTypeNameC (doP, n) ;
-         doTypeNameModifier (doP, n) ;
-         outText (doP, ";\n\n")
+         doTypedef (doP, n)
       END
    END
 END doTypesC ;
@@ -9048,6 +9273,9 @@ BEGIN
    IF n=NIL
    THEN
       outText (p, "void")
+   ELSIF isCDataTypes (n)
+   THEN
+      doCDataTypesC (p, n)
    ELSIF isBase (n)
    THEN
       doBaseC (p, n)
@@ -9078,10 +9306,13 @@ BEGIN
    ELSIF isSet (n)
    THEN
       doSetC (p, n)
+   ELSIF isCDataTypes (n)
+   THEN
+      doCDataTypesC (p, n)
    ELSE
-      (* --fixme--  *)
-      print (p, "to do ...  typedef etc etc ") ; doFQNameC (p, n) ; print (p, ";\n") ;
-      HALT
+      metaError1 ('expecting a type symbol rather than a {%1DMd} {%1DMa}', n) ;
+      flushErrors ;
+      errorAbort0 ('terminating compilation')
    END
 END doTypeC ;
 
@@ -9133,6 +9364,14 @@ BEGIN
    THEN
       outText (p, "void") ;
       setNeedSpace (p)
+   ELSIF n = charStarN
+   THEN
+      outText (p, "char *") ;
+      setNeedSpace (p)
+   ELSIF n = constCharStarN
+   THEN
+      outText (p, "const char *") ;
+      setNeedSpace (p)
    ELSIF isBase (n)
    THEN
       doBaseC (p, n)
@@ -11022,6 +11261,126 @@ BEGIN
 END needsCast ;
 
 
+(*
+   castDestType - emit the destination type ft
+*)
+
+PROCEDURE castDestType (p: pretty; formal, ft: node) ;
+BEGIN
+   doTypeNameC (p, ft) ;
+   IF isVarParam (formal)
+   THEN
+      outText (p, '*')
+   END
+END castDestType ;
+
+
+(*
+   identifyPointer -
+*)
+
+PROCEDURE identifyPointer (type: node) : node ;
+BEGIN
+   IF isPointer (type)
+   THEN
+      IF skipType (getType (type)) = charN
+      THEN
+         RETURN charStarN
+      ELSIF (skipType (getType (type)) = byteN) OR
+            (skipType (getType (type)) = locN)
+      THEN
+         RETURN addressN
+      END
+   END ;
+   RETURN type
+END identifyPointer ;
+
+
+(*
+   castPointer - provides a six way cast between ADDRESS (ie void * ),
+                 char * and const char *.
+*)
+
+PROCEDURE castPointer (p: pretty; actual, formal, at, ft: node) : CARDINAL ;
+VAR
+   sat, sft: node ;
+   parenth : CARDINAL ;
+BEGIN
+   parenth := 0 ;
+   IF at # ft
+   THEN
+      sat := identifyPointer (skipType (at)) ;
+      sft := identifyPointer (skipType (ft)) ;
+      IF sat = addressN
+      THEN
+         IF sft = charStarN
+         THEN
+            outText (p, 'reinterpret_cast <') ;
+            castDestType (p, formal, ft) ;
+            outText (p, '>')
+         ELSIF sft = constCharStarN
+         THEN
+            outText (p, 'const_cast <') ;
+            castDestType (p, formal, ft) ;
+            outText (p, '> (static_cast <') ;
+            doTypeNameC (p, charStarN) ;
+            outText (p, '>') ;
+            INC (parenth)
+         ELSE
+            outText (p, 'reinterpret_cast <') ;
+            castDestType (p, formal, ft) ;
+            outText (p, '>')
+         END
+      ELSIF sat = charStarN
+      THEN
+         IF sft = addressN
+         THEN
+            outText (p, 'reinterpret_cast <') ;
+            castDestType (p, formal, ft) ;
+            outText (p, '>')
+         ELSIF sft = constCharStarN
+         THEN
+            outText (p, 'const_cast <') ;
+            castDestType (p, formal, ft) ;
+            outText (p, '>')
+         ELSE
+            outText (p, 'reinterpret_cast <') ;
+            castDestType (p, formal, ft) ;
+            outText (p, '>')
+         END
+      ELSIF sat = constCharStarN
+      THEN
+         IF sft = addressN
+         THEN
+            outText (p, 'static_cast <') ;
+            castDestType (p, formal, ft) ;
+            outText (p, '> (const_cast <') ;
+            doTypeNameC (p, charStarN) ;
+            outText (p, '>') ;
+            INC (parenth)
+         ELSIF sft = charStarN
+         THEN
+            outText (p, 'const_cast <') ;
+            castDestType (p, formal, ft) ;
+            outText (p, '>')
+         ELSE
+            outText (p, 'reinterpret_cast <') ;
+            castDestType (p, formal, ft) ;
+            outText (p, '>')
+         END
+      ELSE
+         outText (p, 'reinterpret_cast <') ;
+         castDestType (p, formal, ft) ;
+         outText (p, '>')
+      END ;
+      setNeedSpace (p) ;
+      outText (p, '(') ;
+      INC (parenth)
+   END ;
+   RETURN parenth
+END castPointer ;
+
+
 (*
    checkSystemCast - checks to see if we are passing to/from
                      a system generic type (WORD, BYTE, ADDRESS)
@@ -11039,11 +11398,16 @@ BEGIN
    THEN
       IF lang = ansiCP
       THEN
-         IF isString (actual) AND (skipType (ft) = addressN)
+         IF isString (actual) AND isCDataType (skipType (ft))
+         THEN
+            (* Nothing to do.  *)
+            RETURN 0
+         ELSIF isString (actual) AND (skipType (ft) = addressN)
          THEN
             outText (p, "const_cast<void*> (static_cast<const void*> (") ;
 	    RETURN 2
-         ELSIF isPointer (skipType (ft)) OR (skipType (ft) = addressN)
+         ELSIF isPointer (skipType (ft)) OR (skipType (ft) = addressN) OR
+               isCDataType (skipType (ft))
          THEN
             IF actual = nilN
             THEN
@@ -11054,14 +11418,7 @@ BEGIN
                (* NULL is compatible with pointers/address.  *)
                RETURN 0
             ELSE
-               outText (p, 'reinterpret_cast<') ;
-               doTypeNameC (p, ft) ;
-               IF isVarParam (formal)
-               THEN
-                  outText (p, '*')
-               END ;
-               noSpace (p) ;
-               outText (p, '> (')
+               RETURN castPointer (p, actual, formal, at, ft)
             END
          ELSE
             outText (p, 'static_cast<') ;
@@ -18061,6 +18418,22 @@ BEGIN
 END makeBuiltins ;
 
 
+(*
+   makeCDataTypes - assign the charStarN and constCharStarN to NIL.
+*)
+
+PROCEDURE makeCDataTypes ;
+VAR
+   CdatatypesN: node ;
+BEGIN
+   CdatatypesN := lookupDef (makeKey ('CDataTypes')) ;
+   enterScope (CdatatypesN) ;
+   charStarN := makePointer (charN) ;
+   constCharStarN := makePointer (charN) ;
+   leaveScope
+END makeCDataTypes ;
+
+
 (*
    init -
 *)
@@ -18083,7 +18456,8 @@ BEGIN
    makeM2rts ;
    outputState := punct ;
    tempCount := 0 ;
-   mustVisitScope := FALSE
+   mustVisitScope := FALSE ;
+   makeCDataTypes
 END init ;
 
 
diff --git a/gcc/m2/mc/keyc.def b/gcc/m2/mc/keyc.def
index cdf3f67e131..687a310bf82 100644
--- a/gcc/m2/mc/keyc.def
+++ b/gcc/m2/mc/keyc.def
@@ -27,6 +27,20 @@ FROM decl IMPORT node ;
 FROM nameKey IMPORT Name ;
 
 
+(*
+   useGccTree - indicate we have imported tree from gcctypes.
+*)
+
+PROCEDURE useGccTree ;
+
+
+(*
+   useGccLocation - indicate we have imported tree from gcctypes.
+*)
+
+PROCEDURE useGccLocation ;
+
+
 (*
    useUnistd - need to use unistd.h call using open/close/read/write require this header.
 *)
diff --git a/gcc/m2/mc/keyc.mod b/gcc/m2/mc/keyc.mod
index 4436a321225..f3f09309ad5 100644
--- a/gcc/m2/mc/keyc.mod
+++ b/gcc/m2/mc/keyc.mod
@@ -44,6 +44,8 @@ VAR
    initializedCP,
    initializedGCC,
 
+   seenGccTree,
+   seenGccLocation,
    seenIntMin,
    seenUIntMin,
    seenLongMin,
@@ -95,11 +97,32 @@ BEGIN
          initializedGCC := TRUE ;
          print (p, '#include "config.h"\n');
          print (p, '#include "system.h"\n');
+         checkGccTypes (p)
       END
    END
 END checkGccConfigSystem ;
 
 
+(*
+   useGccTree - indicate we have imported tree from gcctypes.
+*)
+
+PROCEDURE useGccTree ;
+BEGIN
+   seenGccTree := TRUE
+END useGccTree ;
+
+
+(*
+   useGccLocation - indicate we have imported tree from gcctypes.
+*)
+
+PROCEDURE useGccLocation ;
+BEGIN
+   seenGccLocation := TRUE
+END useGccLocation ;
+
+
 (*
    useStorage - indicate we have used storage.
 *)
@@ -411,6 +434,20 @@ BEGIN
 END useCtype ;
 
 
+(*
+   checkGccTypes - if we have imported tree or location_t from gcctypes
+                   then we include the gcc headers.
+*)
+
+PROCEDURE checkGccTypes (p: pretty) ;
+BEGIN
+   IF seenGccTree OR seenGccLocation
+   THEN
+      print (p, '#include "gcc-consolidation.h"\n\n')
+   END
+END checkGccTypes ;
+
+
 (*
    checkCtype -
 *)
@@ -419,7 +456,7 @@ PROCEDURE checkCtype (p: pretty) ;
 BEGIN
    IF seenCtype
    THEN
-      checkGccConfigSystem (p);
+      checkGccConfigSystem (p) ;
       IF getGccConfigSystem ()
       THEN
          (* GCC header files use a safe variant.  *)
@@ -1149,6 +1186,8 @@ BEGIN
    seenSize_t := FALSE ;
    seenSSize_t := FALSE ;
    seenSysTypes := FALSE ;
+   seenGccTree := FALSE ;
+   seenGccLocation := FALSE ;
    initializedCP := FALSE ;
    initializedGCC := FALSE ;
 
diff --git a/gcc/m2/mc/mcp1.bnf b/gcc/m2/mc/mcp1.bnf
index 5b9661b4c23..42e41ef52a6 100644
--- a/gcc/m2/mc/mcp1.bnf
+++ b/gcc/m2/mc/mcp1.bnf
@@ -57,7 +57,7 @@ FROM mcLexBuf IMPORT currentstring, currenttoken, getToken, insertToken,
                      insertTokenAndRewind, getTokenNo, lastcomment ;
 
 FROM decl IMPORT node, lookupDef, lookupImp, lookupModule, getSymName,
-                 lookupSym, putDefForC,
+                 lookupSym, putDefForC, putDefUnqualified,
                  makeProcedure, makeType, makeTypeImp, makeVar, makeConst,
 		 enterScope, leaveScope, putTypeHidden, putTypeOpaque,
 		 addImportedModule, getCurrentModule,
@@ -1031,7 +1031,7 @@ Priority := "[" ConstExpression "]" =:
 
 Export := "EXPORT" ( "QUALIFIED"
                                  IdentList |
-                     "UNQUALIFIED"
+                     "UNQUALIFIED"                                     % putDefUnqualified (curmodule) %
                                  IdentList |
                      IdentList ) ";" =:
 

